// global vars from aviary.
var gMustLoadSidebar = false;
var gSidebarCommand = "";
var gWebPanelURI;

var xSidebar = {

  windowStartup : function () {
    window.removeEventListener("load", xSidebar.windowStartup, false);
    var sidebarBox = document.getElementById("sidebar-box");
    if (!sidebarBox) {
      return
    }
    var sidebarSplitter = document.getElementById("sidebar-splitter");
    var sidebarTitle = document.getElementById("sidebar-title");
    var sidebarTitleBox = document.getElementById("sidebar-title-box");
    var sidebarPanelsSplitterBox = document.getElementById("sidebar-panels-splitter-box");

    if (window.opener && !window.opener.closed) {
      var thisWinType = document.documentElement.getAttribute("windowtype");
      var openerWinType = window.opener.document
                          .documentElement.getAttribute("windowtype");
      var openerIsSameType = (thisWinType == openerWinType);
    }
    if (window.opener && !window.opener.closed && openerIsSameType) {
      // If this window is opened from a sidebar link, the opener is the
      // sidebar box not the main window, so we need to use ".top".
      var openerSidebarBox = window.opener.top.document.getElementById("sidebar-box");
      // The opener can be the hidden window too, if we're coming from the state
      // where no windows are open, and the hidden window has no sidebar box.
      if (openerSidebarBox && !openerSidebarBox.hidden) {
        sidebarTitle.setAttribute("value",
          window.opener.top.document.getElementById("sidebar-title").getAttribute("value"));
        sidebarBox.setAttribute("width", openerSidebarBox.boxObject.width);
        var sidebarCmd = openerSidebarBox.getAttribute("sidebarcommand");
        sidebarBox.setAttribute("sidebarcommand", sidebarCmd);
        sidebarBox.setAttribute("src",
          window.opener.top.document.getElementById("sidebar").getAttribute("src"));
        gMustLoadSidebar = true;
        sidebarBox.hidden = false;
        sidebarSplitter.hidden = false;
        var isCollapsed = openerSidebarBox.collapsed;
        if (isCollapsed) {
          sidebarBox.collapsed = true;
          sidebarSplitter.setAttribute("state", "collapsed");
        }
        else if (sidebarSplitter.getAttribute("state") == "collapsed") {
          sidebarSplitter.removeAttribute("state");
        }
        document.getElementById(sidebarCmd).setAttribute("checked", "true");
      }
    }
    else {
      if (sidebarBox.hasAttribute("sidebarcommand")) {
        var commandID = sidebarBox.getAttribute("sidebarcommand");
        if (commandID) {
          var command = document.getElementById(commandID);
          if (command) {
            gMustLoadSidebar = true;
            if (!sidebarBox.hidden) {
              sidebarBox.hidden = false;
              sidebarSplitter.hidden = false;
              if (sidebarSplitter.getAttribute("state") == "collapsed")
                sidebarBox.collapsed = true;
              var title = command.getAttribute("sidebartitle");
              if (!title)
                title = command.getAttribute("label");
              // Since we are now persisting the sidebar-title, don't override it.
              if (!sidebarTitle.getAttribute("value"))
                sidebarTitle.setAttribute("value", title);
              command.setAttribute("checked", "true");
            }
          }
          else {
            // Remove the |sidebarcommand| attribute, because the element it 
            // refers to no longer exists, so we should assume this sidebar
            // panel has been uninstalled. (249883)
            sidebarBox.removeAttribute("sidebarcommand");
            // Hide sidebar since the sidebar has been uninstalled.
            sidebarBox.hidden = true;
            sidebarSplitter.hidden = true;
          }
        }
      }
    }
    if (!gMustLoadSidebar) {
      sidebarBox.hidden = true;
      sidebarSplitter.hidden = true;
      sidebarPanelsSplitterBox.hidden = true;
    }
    setTimeout(xSidebar.delayedStartup, 0);
  },

  delayedStartup : function () {
    if (gMustLoadSidebar) {
      var sidebar = document.getElementById("sidebar");
      var sidebarBox = document.getElementById("sidebar-box");
      sidebar.setAttribute("src", sidebarBox.getAttribute("src"));
    }
  },

  windowShutdown : function () {
    window.removeEventListener("unload", xSidebar.windowShutdown, false);
    document.persist("sidebar-box", "sidebarcommand");
    document.persist("sidebar-box", "width");
    document.persist("sidebar-box", "src");
    document.persist("sidebar-title", "value");
    document.persist("sidebar-title-box", "hidden");
    document.persist("sidebar-splitter", "hidden");
    document.persist("sidebar-splitter", "state");
  },

  sidebarInit : function () {
    window.removeEventListener("load", xSidebar.sidebarInit, false);

    var cssplit = document.getElementById("contacts-pane-splitter");
    if (cssplit) {
      cssplit.parentNode.removeChild(cssplit.nextSibling);
      cssplit.parentNode.removeChild(cssplit);
      document.loadOverlay("chrome://moji/content/tsbSidebar.xul", null)
    }
  }

}

function toggleSidebar(aCommandID, forceOpen) {
    var sidebarBox = document.getElementById("sidebar-box");
    if (!aCommandID)
      aCommandID = sidebarBox.getAttribute("sidebarcommand");
    if (!aCommandID)
      aCommandID = "viewAddressPicker";

    var elt = document.getElementById(aCommandID);
    var sidebar = document.getElementById("sidebar");
    var sidebarTitle = document.getElementById("sidebar-title");
    var sidebarTitleBox = document.getElementById("sidebar-title-box");
    var sidebarSplitter = document.getElementById("sidebar-splitter");

    var sidebarPanelsSplitter = document.getElementById("sidebar-panels-splitter");
    var sidebarPanelsSplitterBox = document.getElementById("sidebar-panels-splitter-box");
    var sidebarMenuItem = document.getElementById("sidebar-menu");

    if ((!forceOpen && elt && elt.getAttribute("checked") == "true")) {
      elt.removeAttribute("checked");
      sidebarTitle.setAttribute("value", "");
      sidebar.removeAttribute("src");

      var hideEverything = sidebarPanelsSplitter.getAttribute("hidden") == "true";
      if (hideEverything) {
        dump("\nSidebar: Hide everything");
        sidebarBox.collapsed = true;
        sidebarBox.hidden = true;
        sidebarBox.setAttribute("sidebarVisible", "false");
        //sidebarBox.setAttribute("sidebarcommand", "");
        sidebarSplitter.hidden = true;
      } else {
        sidebarPanelsSplitter.hidden = true;
      }
      sidebarTitleBox.hidden = true;
      sidebarPanelsSplitterBox.collapsed = true;
      sidebarPanelsSplitterBox.hidden = true; // test
      sidebarMenuItem.setAttribute("checked", "false");

      window.content.focus();
      return;
    }

    sidebarBox.hidden = false;
    sidebarBox.removeAttribute("collapsed");
    sidebarBox.setAttribute("sidebarVisible", "true");
    sidebarTitleBox.hidden = false;
    sidebarPanelsSplitterBox.hidden = false;
    sidebarPanelsSplitterBox.removeAttribute("collapsed");
    sidebarMenuItem.setAttribute("checked", "true");

    sidebarSplitter.hidden = false;
    if (sidebarSplitter.getAttribute("state") == "collapsed")
      sidebarSplitter.removeAttribute("state");

    var elts = document.getElementsByAttribute("group", "sidebar");
    for (var i = 0; i < elts.length; i++)
      elts[i].removeAttribute("checked");

    elt.setAttribute("checked", "true");

    var url = elt.getAttribute("sidebarurl");
    var title = elt.getAttribute("sidebartitle");
    if (!title)
      title = elt.getAttribute("label");
    sidebar.setAttribute("src", url);
    sidebarBox.setAttribute("src", url);
    sidebarBox.setAttribute("sidebarcommand", elt.id);
    sidebarTitle.setAttribute("value", title);
    document.persist("sidebar-box", "sidebarcommand");
    document.persist("sidebar-box", "width");
    document.persist("sidebar-box", "src");
    document.persist("sidebar-title-box", "hidden");
    document.persist("sidebar-title", "value");
    document.persist("sidebar-splitter", "hidden");
    document.persist("sidebar-splitter", "state");

    window.content.focus();
}

window.addEventListener("load",   xSidebar.windowStartup,  false);
window.addEventListener("load",   xSidebar.sidebarInit,    false);
window.addEventListener("unload", xSidebar.windowShutdown, false);
